{**********************************************************************}
{*    "OpenGL   Delphi"                     *}
{*  .. softgl@chat.ru                                        *}
{**********************************************************************}

{/*
 * (c) Copyright 1993, Silicon Graphics, Inc.
 *               1993-1995 Microsoft Corporation
 *
 * ALL RIGHTS RESERVED
 */}

unit yy;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OpenGL, StdCtrls,evalcomp, ExtCtrls, Menus, ExtDlgs, ComCtrls, Spin;

type
  TfrmGL = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Button1: TButton;
    CheckBox1: TCheckBox;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    Label1: TLabel;
    Edit1: TEdit;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox2: TCheckBox;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    SpinButton3: TSpinButton;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure N2Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton3DownClick(Sender: TObject);
    procedure SpinButton3UpClick(Sender: TObject);
  private
    DC : HDC;
    hrc: HGLRC;

  end;

var
  frmGL: TfrmGL;
  wrkX, wrkY : Integer;
  mode : Boolean = False;
  down : Boolean = False;
  solid : Boolean = True;

implementation

uses Unit1;
const
count=140;

{$R *.DFM}
var zz,xt,zt,yt:glfloat;
ol:string;
 calc: EVALVEC ;
 ff:boolean;
 zzz:array[-count*4..count*4,-count*4..count*4] of glfloat;

 procedure Axes;
var
  Color : Array [1..4] of GLFloat;
begin
  glPushMatrix;

  glGetFloatv (GL_CURRENT_COLOR, @Color);

//  glScalef (0.75, 0.75, 0.75);
  glColor3f (0, 4, 0);
  glBegin (GL_LINES);
    glVertex3f (0, 0, 0);
    glVertex3f (3, 0, 0);
    glVertex3f (0, 0, 0);
    glVertex3f (0, 3, 0);
    glVertex3f (0, 0, 0);
    glVertex3f (0, 0, 3);
  glEnd;
        //  X
  glBegin (GL_LINES);
    glVertex3f (3.1, -0.2, 0.5);
    glVertex3f (3.1, 0.2, 0.1);
    glVertex3f (3.1, -0.2, 0.1);
    glVertex3f (3.1, 0.2, 0.5);
  glEnd;

  //  Y
  glBegin (GL_LINES);
    glVertex3f (0.0, 3.1, 0.0);
    glVertex3f (0.0, 3.1, -0.1);
    glVertex3f (0.0, 3.1, 0.0);
    glVertex3f (0.1, 3.1, 0.1);
    glVertex3f (0.0, 3.1, 0.0);
    glVertex3f (-0.1, 3.1, 0.1);
  glEnd;

  //  Z
  glBegin (GL_LINES);
    glVertex3f (0.1, -0.1, 3.1);
    glVertex3f (-0.1, -0.1, 3.1);
    glVertex3f (0.1, 0.1, 3.1);
    glVertex3f (-0.1, 0.1, 3.1);
    glVertex3f (-0.1, -0.1, 3.1);
    glVertex3f (0.1, 0.1, 3.1);
  glEnd;

  //    
  glColor3f (Color [1], Color [2], Color [3]);

  glPopMatrix;


end;



procedure TfrmGL.FormPaint(Sender: TObject);


var
 m,i, j : Integer;
 x,y,z,x1,y1,z1:glfloat;

begin
axes;
if ff then begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

 glPushMatrix;
  glScalef (0.25, 0.25, 0.25);
  glColor3f (0, 1, 0);

  glBegin (GL_LINES);
    glVertex3f (0, 0, 0);
    glVertex3f (3, 0, 0);
    glVertex3f (0, 0, 0);
    glVertex3f (0, 3, 0);
    glVertex3f (0, 0, 0);
    glVertex3f (0, 0, 3);
  glEnd;

  glColor3f (1, 1, 1);

        //  X
  glBegin (GL_LINES);
    glVertex3f (3.1, -0.2, 0.5);
    glVertex3f (3.1, 0.2, 0.1);
    glVertex3f (3.1, -0.2, 0.1);
    glVertex3f (3.1, 0.2, 0.5);
  glEnd;

  //  Y
  glBegin (GL_LINES);
    glVertex3f (0.0, 3.1, 0.0);
    glVertex3f (0.0, 3.1, -0.1);
    glVertex3f (0.0, 3.1, 0.0);
    glVertex3f (0.1, 3.1, 0.1);
    glVertex3f (0.0, 3.1, 0.0);
    glVertex3f (-0.1, 3.1, 0.1);
  glEnd;

  //  Z
  glBegin (GL_LINES);
    glVertex3f (0.1, -0.1, 3.1);
    glVertex3f (-0.1, -0.1, 3.1);
    glVertex3f (0.1, 0.1, 3.1);
    glVertex3f (-0.1, 0.1, 3.1);
    glVertex3f (-0.1, -0.1, 3.1);
    glVertex3f (0.1, 0.1, 3.1);
  glEnd;
















 glColor3f (1.0, 0.0, 1.0);
 {xstep:=(xmax-xmin)/xcount;
 ystep:=(ymax-ymin)/ycount;
  }
m:=round(((count div 2)/zz)*0.3);






    for i:=-m to m do
     begin
         glBegin (GL_line_strip);

       for j:=-m to m do
        begin
        x:=i*zz;
        y:=j*zz;
        z:=zzz[i,j];
        glvertex3f(x,y,z);
        end;
        glEnd;
        end;
    for i:=-m to m do
     begin
         glBegin (GL_line_strip);

       for j:=-m to m do
        begin
        y:=i*zz;
        x:=j*zz;
          z:=zzz[j,i];
        glvertex3f(x,y,z);
        end;
        glEnd;
        end;



    glEnable (GL_LIGHTING);


 glPopMatrix;

 SwapBuffers(DC);
 end;
end;

{=======================================================================
 }
procedure SetDCPixelFormat (hdc : HDC);
var
 pfd : TPixelFormatDescriptor;
 nPixelFormat : Integer;
begin
 FillChar (pfd, SizeOf (pfd), 0);
 pfd.dwFlags  := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
 nPixelFormat := ChoosePixelFormat (hdc, @pfd);
 SetPixelFormat (hdc, nPixelFormat, @pfd);
end;

{=======================================================================
 }
procedure TfrmGL.FormCreate(Sender: TObject);
begin

ff:=false;
 DC := GetDC (Handle);
 SetDCPixelFormat(DC);
 hrc := wglCreateContext(DC);
 wglMakeCurrent(DC, hrc);

 glEnable(GL_DEPTH_TEST);
 glEnable (GL_AUTO_NORMAL);
 glEnable (GL_NORMALIZE);
 glEnable (GL_COLOR_MATERIAL);

 //  
 glEnable(GL_LIGHTING);
 glEnable(GL_LIGHT0);
 glPointSize (5.0);



end;

{=======================================================================
  }
procedure TfrmGL.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0, 0);
 wglDeleteContext(hrc);
 ReleaseDC (Handle, DC);
 DeleteDC (DC);
end;

procedure TfrmGL.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Key = VK_ESCAPE then Close;
  If Key = VK_LEFT then begin
    xt :=  - 5.0;
     glrotatef(xt,1,0,0);
    invalidateRect(Handle, nil, False);
 end;
 If Key = VK_RIGHT then begin
    xt := + 5.0;
    glrotatef(xt,1,0,0);
    InvalidateRect(Handle, nil, False);
 end;
  If Key = VK_up then begin
    yt :=  + 5.0;
     glrotatef(yt,0,1,0);
    invalidateRect(Handle, nil, False);
 end;
 If Key = VK_down then begin
    zt :=  + 5.0;
    glrotatef(zt,0,0,1);
    InvalidateRect(Handle, nil, False);
 end;








end;

procedure TfrmGL.FormResize(Sender: TObject);
begin
 glViewport(0, 0, ClientWidth, ClientHeight);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 gluPerspective (30.0, ClientWidth / ClientHeight, 3.0, 8.0);
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity;
 glTranslatef (0.0, 0.0, -5.0);

 InvalidateRect(Handle, nil, False);
end;


procedure TfrmGL.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Down := True;
  wrkX := X;
  wrkY := Y;
end;

procedure TfrmGL.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Down := False;
end;

procedure TfrmGL.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  If Down then begin
     glRotatef (X - wrkX, 0.0, 1.0, 0.0);
     glRotatef (Y - wrkY, 1.0, 0.0, 0.0);
     InvalidateRect(Handle, nil, False);
     wrkX := X;
     wrkY := Y;
  end;
end;

procedure TfrmGL.Button1Click(Sender: TObject);
function fun(x,y:glfloat):glfloat;
begin
fun:=calc^.eval2d(x,y)
  
end;


var
 m,i, j : Integer;
x,y,z:glfloat;

var fo:string;
begin
zz:=strtofloat(edit1.Text);

m:=round(((count div 2)/zz)*0.3);

ff:=true;
fo:=combobox1.Text;
if fo<>ol then combobox1.Items.Add(ol);
ol:=fo;
new (calc,init(FO));
calc^.s1(false);



    for i:=-m to m do
                for j:=-m to m do
        begin
        x:=i*zz;
        y:=j*zz;
        z:=fun(x,y);
        zzz[i,j]:=z;
        end;







InvalidateRect(Handle, nil, False);

end;

procedure TfrmGL.CheckBox1Click(Sender: TObject);
begin
if checkbox1.checked then
begin panel1.Visible:=true ;
label1.Visible:=true;
edit1.Visible:=true;


end
else
begin

panel1.Visible:=false;
label1.Visible:=not true;
edit1.Visible:=not true;

end;
end;

procedure TfrmGL.FormClose(Sender: TObject; var Action: TCloseAction);
begin

form1.Visible:=not false;
yy.frmGL.Visible:=not true;
end;

procedure TfrmGL.N2Click(Sender: TObject);
begin
form1.Visible:=not false;
yy.frmGL.Visible:=not true;

end;

procedure TfrmGL.CheckBox2Click(Sender: TObject);
begin
if checkbox1.checked then
panel2.Visible:=true else panel2.Visible:=false;

end;

procedure TfrmGL.SpinButton1DownClick(Sender: TObject);
begin
glrotatef(-3,1,0,0);
    InvalidateRect(Handle, nil, False);


end;

procedure TfrmGL.SpinButton1UpClick(Sender: TObject);
begin
glrotatef(3,1,0,0);
    InvalidateRect(Handle, nil, False);

end;

procedure TfrmGL.SpinButton2DownClick(Sender: TObject);
begin
glrotatef(-3,0,1,0);
    InvalidateRect(Handle, nil, False);

end;

procedure TfrmGL.SpinButton2UpClick(Sender: TObject);
begin
glrotatef(3,0,1,0);
    InvalidateRect(Handle, nil, False);

end;

procedure TfrmGL.SpinButton3DownClick(Sender: TObject);
begin
glrotatef(-3,0,0,1);
    InvalidateRect(Handle, nil, False);

end;

procedure TfrmGL.SpinButton3UpClick(Sender: TObject);
begin
glrotatef(3,0,0,1);
    InvalidateRect(Handle, nil, False);

end;

end.

